VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPacket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Inbound     As String
Private Outbound    As String
Private lngPosition As Long
Public Sub ClearOutbound()
    Outbound = vbNullString
End Sub
Public Function CreateWORD(ByVal Value As Integer) As String
Dim Result As String * 2
    RtlMoveMemory ByVal Result, Value, 2
    CreateWORD = Result
End Function
Public Function CreateDWORD(ByVal Value As Long) As String
Dim Result As String * 4
    RtlMoveMemory ByVal Result, Value, 4
    CreateDWORD = Result
End Function
Public Sub Skip(ByVal intBytes As Integer)
    lngPosition = lngPosition + intBytes
End Sub
Public Sub SkipNTString()
Dim rVal As String
    If InStr(Inbound, vbNullChar) > 0 Then
        If Len(Inbound) > 0 Then
            If Len(Mid$(Inbound, lngPosition)) > 0 Then
                rVal = TrimNull(Mid$(Inbound, lngPosition))
                lngPosition = lngPosition + Len(rVal) + 1
            End If
        End If
    End If
End Sub
Public Function GetData() As String
    GetData = Inbound
End Function
Public Function GetNull() As String
    GetNull = Mid$(Inbound, lngPosition)
End Function
Public Function GetByte() As Byte
    If Len(Inbound) >= lngPosition Then
        GetByte = Asc(Mid$(Inbound, lngPosition, 1))
        lngPosition = lngPosition + 1
    End If
End Function
Public Function GetWORD() As Long
Dim rVal As Long
    If Len(Inbound) - lngPosition + 1 >= 2 Then
        RtlMoveMemory rVal, ByVal Mid$(Inbound, lngPosition, 2), 2
        lngPosition = lngPosition + 2
        GetWORD = rVal
    End If
End Function
Public Function GetDWORD() As Long
Dim rVal As Long
    If Len(Inbound) - lngPosition + 1 >= 4 Then
        RtlMoveMemory rVal, ByVal Mid$(Inbound, lngPosition, 4), 4
        lngPosition = lngPosition + 4
        GetDWORD = rVal
    End If
End Function
Public Function GetNTString() As String
Dim rVal As String
    If InStr(Inbound, vbNullChar) > 0 Then
        If Len(Inbound) > 0 Then
            If Len(Mid$(Inbound, lngPosition)) > 0 Then
                rVal = TrimNull(Mid$(Inbound, lngPosition))
                lngPosition = lngPosition + Len(rVal) + 1
                GetNTString = rVal
            End If
        End If
    End If
End Function
Public Function GetString(ByVal lngLength As Long) As String
Dim rVal As String
    If Len(Inbound) > 0 Then
        rVal = Mid$(Inbound, lngPosition, lngLength)
        lngPosition = lngPosition + Len(rVal)
        GetString = rVal
    End If
End Function
Public Sub InsertByte(ByVal Data As Byte)
    Outbound = Outbound & Chr$(Data)
End Sub
Public Sub InsertWORD(ByVal Data As Integer)
    Outbound = Outbound & CreateWORD(Data)
End Sub
Public Sub InsertDWORD(ByVal Data As Long)
    Outbound = Outbound & CreateDWORD(Data)
End Sub
Public Sub InsertNTString(ByVal Data As String)
    Outbound = Outbound & Data & vbNullChar
End Sub
Public Sub InsertString(ByVal Data As String)
    Outbound = Outbound & Data
End Sub
Public Function GetOutbound() As String
  GetOutbound = Outbound
End Function
Public Function SendBNCSPacket(ByVal PacketID As Byte) As String
    Outbound = Chr$(&HFF) & Chr$(PacketID) & CreateWORD(Len(Outbound) + 4) & Outbound
    SendBNCSPacket = Outbound
    Outbound = vbNullString
End Function
Public Function SendFTPPacket() As String
    Outbound = CreateWORD(Len(Outbound) + 2) & Outbound
    SendFTPPacket = Outbound
    Outbound = vbNullString
End Function
Public Sub SetData(ByVal strValue As String)
    Inbound = strValue
    lngPosition = 1
End Sub
Private Function TrimNull(Item As String) As String
Dim Pos As Integer
    Pos = InStr(1, Item, vbNullChar)
    If Pos Then
        TrimNull = Left$(Item, Pos - 1)
    Else
        TrimNull = Item
    End If
End Function

